ele.slope <-
function(r.dem,n.bin)
{
#calculate slope
r.slope<-terrain(r.dem,opt = "slope")  
#reduce elevation values to slope values - boarder effect of input
r.dem<-r.slope/r.slope*r.dem
#generate intervals
na.max <- function(x) ifelse( !all(is.na(x)), max(x, na.rm=T), NA)
na.min <- function(x) ifelse( !all(is.na(x)), min(x, na.rm=T), NA)
min.ele<-na.min(r.dem[])
max.ele<-na.max(r.dem[])
range.ele<-max.ele-min.ele
ele.interval<-seq(min.ele,max.ele,range.ele/n.bin)
#get Values
ele<-na.omit(r.dem[])
slo<-na.omit(r.slope)
M.ele.slo<-matrix(NA,nrow=(length(ele.interval)-1),ncol=7)
colnames(M.ele.slo)<-c("low","high","mean","median","25% percentile","75% percentile","n")
#get values within intervals
for (i in c(0:(length(ele.interval)-1)))
{
  stat.summary<-summary(slo[ele>=ele.interval[i] & ele<ele.interval[i+1]])
  M.ele.slo[i,7]<-as.numeric(length(slo[ele>=ele.interval[i] & ele<ele.interval[i+1]]))
  M.ele.slo[i,6]<-as.numeric(stat.summary["3rd Qu."])
  M.ele.slo[i,5]<-as.numeric(stat.summary["1st Qu."])
  M.ele.slo[i,4]<-as.numeric(stat.summary["Median"])
  M.ele.slo[i,3]<-as.numeric(stat.summary["Mean"])
  M.ele.slo[i,2]<-as.numeric(ele.interval[i])
  M.ele.slo[i,1]<-as.numeric(ele.interval[i+1])  
}
return(M.ele.slo)
}
