hough.rough <-
function(r.th,r.th.points,r.dire,r.rough,angle,bin,dist.th,angle.th)
{  
#define connected areas
r.th.for.clump<-r.th
r.th.for.clump[]<-ifelse(is.na(r.th[]),0,1)
r.th.clump<-clump(r.th.for.clump)
r.points.clump<-r.th.points/r.th.points*r.th.clump
#build data frame
data.comp<-matrix(NA,ncol=6,nrow=sum(!is.na(r.th.points[])))
colnames(data.comp)<-c("x","y","id_area","dire","rough","id_line")
points<-xyFromCell(r.points.clump,which(!is.na(r.points.clump[])))
data.comp[,1]<-points[,1]
data.comp[,2]<-points[,2]
data.comp[,3]<-extract(r.points.clump,points)
data.comp[,4]<-extract(r.dire,points)
data.comp[,5]<-extract(r.rough,points)
#use areas with more than 1 point
id.area.counts<-as.data.frame(table(data.comp[,3]))
id.use<-as.numeric(as.vector(id.area.counts[id.area.counts[,2]>1,1]))
#get maximum resolution to enlarge extent
res.max<-max(res(r.th))
#calculate angle bins for houghtransformation
dif.angles<-seq(-angle+bin,angle,bin)
#calculate maximum possible line length 
diag=sqrt(r.th@extent@xmax^2+r.th@extent@ymax^2)*2
#output dummies
linessd<-list()
rough.pointssd<-list()
rough.pointss<-list()
liness<-list()
#start of calculation for single areas
for (k in id.use)
{
  #build vec hull for area
  zone<-r.th.clump
  zone[]<-ifelse(zone[]==k,1,0)
  zone[]<-ifelse(is.na(zone[]),0,zone[])
  if(sum(zone[]==1)>10) #threshold for minimum area(10 pixels)
  {
    ext.zone<-extend(zone, c(res.max,res.max),value=0) #enlarge extent of area
    vec.hull<-tryCatch(rasterToContour(ext.zone), error = function(e) e) #calculate vector hull of zone, if not possible this zone is skipped
    if(inherits(vec.hull, "error")) next
    
    #get variables for area
    points<-data.comp[data.comp[,3]==k,1:2]
    dires<-data.comp[data.comp[,3]==k,4]
    roughs<-data.comp[data.comp[,3]==k,5]
    #shift points to the position where midpoint of used raster input is 0/0
    points[,1]<-points[,1]+((-r.th@extent@xmin-r.th@extent@xmax)/2)
    points[,2]<-points[,2]+((-r.th@extent@ymin-r.th@extent@ymax)/2)
    #calculate angle matrix
    M.angles.lin<-matrix(NA,ncol=length(dif.angles),nrow=length(dires))
  for (i in c(1:length(dif.angles)))
  {
    M.angles.lin[,i]<-dires+dif.angles[i]
  }
  M.angles.lin<-ifelse(M.angles.lin<0,M.angles.lin+180,M.angles.lin)
  M.angles.lin<-ifelse(M.angles.lin>180,M.angles.lin-180,M.angles.lin)
  x2.dires<-cos(M.angles.lin*pi/180)+points[,1]
  y2.dires<-sin(M.angles.lin*pi/180)+points[,2]
  #calculate perpendecular angle matrix, rho in houghspace
  M.angles.per<-M.angles.lin+90
  M.angles.per<-ifelse(M.angles.per>=180,M.angles.per-180,M.angles.per)
  nx.dires.per<-cos(M.angles.per*pi/180)
  ny.dires.per<-sin(M.angles.per*pi/180)
  #calculate phi in houghspace
  x.inters<-(points[,1]*y2.dires-points[,2]*x2.dires)*(-nx.dires.per)/((points[,1]-x2.dires)*(-ny.dires.per)-(points[,2]-y2.dires)*(-nx.dires.per))
  y.inters<-(points[,1]*y2.dires-points[,2]*x2.dires)*(-ny.dires.per)/((points[,1]-x2.dires)*(-ny.dires.per)-(points[,2]-y2.dires)*(-nx.dires.per))
  phi<-sqrt(x.inters^2+y.inters^2)
  phi<-ifelse(y.inters<0,-phi,phi)
  #houghspace dataframe
  data<-matrix(NA,ncol=2,nrow=length(M.angles.per))
  data[,1]<-as.numeric(M.angles.per)
  data[,2]<-as.numeric(phi)
  #assign roughness to points in houghspace
  M.roughs<-matrix(NA,ncol=ncol(M.angles.per),nrow=nrow(M.angles.per))
  for (i in c(1:ncol(M.roughs)))
  {  
    M.roughs[,i]<-roughs
  }
  #lower level output dummies
  rough.pointss<-list()
  liness<-list()
  #multiple maximum finding in hough space
  j=1
  while (length(points)>2)
  {
    #generate points density map and find maximum
    p <- SpatialPoints(matrix(c(as.numeric(M.angles.per),as.numeric(phi)),ncol=2,nrow=length(phi)))
    p <- as.ppp(p)
    roughs<-as.numeric(M.roughs)
    d <- density.ppp(p,sigma=1/nrow(points),weights = roughs,edge=T)
    #d <- density.ppp(p,sigma=1000,edge=T)
    rd<-raster(d)
    densi<-max(rd[])
    max.dp<-which.max(rd[])
    max.hough<-xyFromCell(rd, which.max(rd[]))
    #if two maximum values, take the first
    if(length(max.hough)>2)
    {
      max.hough<-max.hough[1,]
    }
    #calculate lines in normal space according to maximum position in houghspace 
    x.normal=(max.hough[2]*cos(max.hough[1]*pi/180))
    y.normal=(max.hough[2]*sin(max.hough[1]*pi/180))
    x2.normal<-x.normal+cos((max.hough[1]-90)*pi/180)*diag
    y2.normal<-y.normal+sin((max.hough[1]-90)*pi/180)*diag
    x3.normal<-x.normal-cos((max.hough[1]-90)*pi/180)*diag
    y3.normal<-y.normal-sin((max.hough[1]-90)*pi/180)*diag
    line<-spLines(matrix(c(x3.normal,x2.normal,y3.normal,y2.normal),ncol=2,nrow=2))
    #identify points in normal space that build line
    builder<-which((gDistance(SpatialPoints(points),line,byid = T)<=dist.th) & ((sqrt((dires-max.hough[1])^2))>90-angle.th | (sqrt((dires-max.hough[1])^2))<90+angle.th))
    #shift position of points to input raster extent
    x2.normal<-x2.normal+(r.th@extent@xmin+r.th@extent@xmax)/2
    x3.normal<-x3.normal+(r.th@extent@xmin+r.th@extent@xmax)/2
    y2.normal<-y2.normal+(r.th@extent@ymin+r.th@extent@ymax)/2
    y3.normal<-y3.normal+(r.th@extent@ymin+r.th@extent@ymax)/2
    #generate line
    line<-spLines(matrix(c(x3.normal,x2.normal,y3.normal,y2.normal),ncol=2,nrow=2))
    proj4string(line)<-projection(r.th)
    #find intersection of used area with line
    inters.in<-gIntersection(vec.hull[1,],line)
      #compute lines that lie inside area and have at least one corresponding point
      if(length(inters.in)>1)
      {  
        lines<-list()
        id.zw<-1 
        for (m in seq(1,length(inters.in@coords)/2,2))
        {
          lines[[id.zw]]<-spLines((matrix(c(inters.in@coords[m,1],inters.in@coords[m+1,1],inters.in@coords[m,2],inters.in@coords[m+1,2]),ncol=2,nrow=2)))  
          id.zw<-1+id.zw
        }
        points.dem<-points[builder,]
        roughs.dem<-roughs[builder]
        if(length(points.dem)>2)
        {  
        points.dem[,1]<-points.dem[,1]+(r.th@extent@xmin+r.th@extent@xmax)/2
        points.dem[,2]<-points.dem[,2]+(r.th@extent@ymin+r.th@extent@ymax)/2
        o=1
        lines2<-list()
        n.points<-list()
        dens<-list()
        rough.points<-list()
        for (n in c(1:length(lines)))
        {
          if(sum((gDistance(SpatialPoints(points.dem),lines[[n]],byid = T)<=dist.th))>1)
          {
            lines2[[o]]<-lines[[n]]
            n.points[[o]]<-sum((gDistance(SpatialPoints(points.dem),lines[[n]],byid = T)<=dist.th))
            dens[[o]]<-densi
            builder2<-which((gDistance(SpatialPoints(points.dem),lines[[n]],byid = T)<=dist.th))
            rough.points[[o]]<-mean(roughs.dem[builder2])
            o=o+1
          }
          
        }
        liness[[j]]<-lines2
        rough.pointss[[j]]<-rough.points
      }
    }
    dires<-dires[-builder]
    points<-points[-builder,]
    M.angles.per<-M.angles.per[-builder,]
    M.roughs<-M.roughs[-builder,]
    phi<-phi[-builder,]
    j=j+1
  }}
  
  linessd[[k]]<-unlist(liness)
  rough.pointssd[[k]]<-unlist(rough.pointss)
}
lines.fine<-unlist(linessd)
rough.points.final<-unlist(rough.pointssd)
return(list(lines.fine,rough.points.final))
}
