toporough <-
function (dem,type,ngbr,nform,k.diff) {
  #check & get resolution
  res<-(xres(dem)+yres(dem))/2
  #print warning if x and y resolution are deverse, but calculate anyway
  if(yres(dem)!=xres(dem))
  {
  warning("Different raster resolution in x and y direction: (xres+yres)/2 has been used as overall resolution.")  
  }  
  #calculate parameters
  n.cells.raster<-length(dem[])
  ngbr.sq<-ngbr^2
  n.neigh<-(ngbr-1)/2
  mid.coor<-(ngbr+1)/2
  #define distance matrix M.dist
  M1.dist<-matrix(1:ngbr,ncol = ngbr, nrow = ngbr, byrow = T)
  M2.dist<-matrix(1:ngbr,ncol = ngbr, nrow = ngbr)
  M.dist<-sqrt((M2.dist-M1.dist[mid.coor,mid.coor])*(M2.dist-M1.dist[mid.coor,mid.coor])+(M1.dist-M2.dist[mid.coor,mid.coor])*(M1.dist-M2.dist[mid.coor,mid.coor]))
  #define distances within neighborhood window
  v.dist<-c(M.dist[1:((ngbr.sq-1)/2)])
  M.point.x<-matrix(v.dist,ncol=((ngbr.sq-1)/2),nrow=n.cells.raster,byrow = T)
  M.point.x<-M.point.x*res
  #calculate focal Matrix of dem
  M.dem<-getValuesFocal(dem, ngb=ngbr, names=TRUE)
  #reduce neighborhood to circle if set
  if (nform=="circ") {
    M.dist.circ<-M.dist
    M.dist.circ[M.dist.circ[]>(ngbr-1)/2]<-NA
    v.dist.circ<-c(M.dist.circ[1:(ngbr.sq)])
    v.dist.circ[!is.na(v.dist.circ)]<-1
    M.dem<-t(t(M.dem)*v.dist.circ)
  }
  #max & min functions that handle NA values 
  na.max <- function(x) ifelse( !all(is.na(x)), max(x, na.rm=T), NA)
  na.min <- function(x) ifelse( !all(is.na(x)), min(x, na.rm=T), NA)
  #calculate d and k
  M.point.k<-(M.dem[,(ngbr.sq):(((ngbr.sq+1)/2)+1)]-((M.dem[,1:(((ngbr.sq)-1)/2)])))/(-M.point.x*2)
  if (!is.na(k.diff))
  {
    M.point.k<-ifelse(M.point.k>=-k.diff & M.point.k<=k.diff,M.point.k,NA)
  }
  M.point.y<-M.dem[,(ngbr.sq):(((ngbr.sq+1)/2)+1)]
  M.point.d<-M.point.y-((M.point.k*(-M.point.x)))
  #calculate roughness parameter
  M.point.d.ver<-(M.point.d-M.dem[,(ngbr.sq+1)/2])/M.point.x/2
  #get max/min values and position in matrix
  if (type=="min")
  {
  rough<-apply(M.point.d.ver,1,na.min)
  rough.pos<-as.numeric(apply(M.point.d.ver,1,which.min)) 
  }else{
  rough<-apply(M.point.d.ver,1,na.max)
  rough.pos<-as.numeric(apply(M.point.d.ver,1,which.max))  
  }
  #generate output 
  r.rough<-dem
  r.rough[]<-rough
  r.pos<-dem
  r.pos[]<-rough.pos
  r.k<-dem
  r.k[]<-sqrt((M.point.k[cbind(1:nrow(M.point.k),rough.pos)])^2)
  r.width<-dem
  r.width[]<-M.point.x[cbind(1:nrow(M.point.x),rough.pos)]*2
  r.d<-dem
  r.d[]<-M.point.d[cbind(1:nrow(M.point.d),rough.pos)]
  r.d<-r.d-dem
  #calculate r.dire
  v.dire<-rep(c(rep(-1,(ngbr-1)/2),rep(1,(ngbr+1)/2)),ngbr)
  M1.dire<-matrix(((ngbr-1)/-2):((ngbr-1)/2),ncol = ngbr, nrow = ngbr, byrow = T)
  M2.dire<-(-1)*(matrix(((ngbr-1)/-2):((ngbr-1)/2),ncol = ngbr, nrow = ngbr))
  M.dire<-((M2.dire)/(sqrt(M1.dire^2+M2.dire^2)))
  M.dire<-acos(M.dire)*180/pi
  M.dire<-t(t(M.dire)*v.dire)
  M.dire<-t(M.dire)
  v.dire<-M.dire[1:((ngbr.sq-1)/2)]
  v.dire<-ifelse(v.dire<0,v.dire+180,v.dire)
  r.dire<-r.pos
  r.dire[]<-v.dire[r.pos[]]
  gc()
  return((c(r.rough,r.k,r.d,r.dire,r.width)))
}
