\name{extrema}
\alias{extrema}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Local minimum distance extrema of RasterLayers.
}
\description{
Simple function to compute local extrema (maximum or minimum) of RasterLayers with a minimum distance threshold. Uses command focal() of the raster package.
}
\usage{
extrema(r, ngbr, type)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{r}{
Object of type RasterLayer generated by the command raster() in the raster package.
}
  \item{ngbr}{
Odd number defines the used moving window size (n*n) and therefore the minimum distance of two local extrema. The minimum distance is (ngbr²+1)/2 *resolution.
}
  \item{type}{
"min" or "max", for local minima or maxima.
}
}
\details{
Local extrama are defined by the position of the extreme value within a neighborhood. If the position of the extreme value within a neighborhood is in the center of the neighborhood, than the cell represents a local extrema. The minimum distance between two extrema is defined by the moving window size: (ngbr²+1)/2 *resolution. Depending on your x and y resolution the minimum distance might be different in x and y direction. 
}
\value{
Object of type RasterLayer with cell value 1 for local extrema and NA for the rest.
}
\references{
}
\author{
Sebastian Baumann
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
#searching for the highest peaks in Austria.
data("work.data",package="lineaDEM") #import data
dem.austria<-work.data[[1]]
r.peaks<-extrema(dem.austria,13,"max") #calculate local maxima
p.peaks<-xyFromCell(r.peaks,which(!is.na(r.peaks[]))) #xy of peaks
#eliminate edge pixels
adj<-adjacent(dem.austria,which(!is.na(r.peaks[])),directions=8,sorted=TRUE,id=TRUE)
adj.values<-extract(dem.austria,adj[,3])
p.peaks<-p.peaks[-unique(adj[which(is.na(adj.values)),1]),]
plot(dem.austria) #plot dem
points(p.peaks,pch=20) #plot highest peaks

## The function is currently defined as
function (r, ngbr, type) 
{
    mid.coor <- (ngbr^2 + 1)/2
    if (type == "min") {
        rp <- focal(r, matrix(1, ncol = ngbr, nrow = ngbr), which.min)
    }
    else {
        rp <- focal(r, matrix(1, ncol = ngbr, nrow = ngbr), which.max)
    }
    rp[] <- ifelse(rp[] == mid.coor, 1, NA)
    return(rp)
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
