\name{hypso}
\alias{hypso}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Hypsometric analysis
}
\description{
Calculates hypsometric curves, relative hypsometric curves and hypsometric integral from DEMs.
}
\usage{
hypso(r.dem, min.ele)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{r.dem}{
A digital elevation model of object type RasterLayer generated by the command raster() in the raster package.
}
  \item{min.ele}{
Numerical, minimum elevation - Elevations greater than min.ele are used to perform hypsometric analysis. If NA all values are used.
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
\item{comp1}{Data frame, sorted from high to low elevations: col1: cumulative area, col2: absolute elevation values, col3: relative elevation values}
\item{comp2 }{Hypsometric integral}
}
\references{
Strahler, Arthur N. "Hypsometric (area-altitude) analysis of erosional topography." Geological Society of America Bulletin 63.11 (1952): 1117-1142.
}
\author{
Sebastian Baumann
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
raster
}
\examples{
data("work.data",package="lineaDEM") #import data
dem.austria<-work.data[[1]]
l.hypso<-hypso(dem.austria,NA) #use function
plot(l.hypso[[1]][,1],l.hypso[[1]][,2],
xlab="cumulative relative area",ylab="elevation [m]",type="n")
lines(l.hypso[[1]][,1],l.hypso[[1]][,2])


## The function is currently defined as
function (r.dem, min.ele) 
{
    if (is.na(min.ele)) {
        elev <- r.dem[]
        elev <- na.omit(elev)
    }
    else {
        elev <- ifelse(r.dem[] >= min.ele, r.dem[], NA)
        elev <- na.omit(elev)
    }
    data <- matrix(NA, nrow = length(elev), ncol = 3)
    colnames(data) <- c("cumulative relative area", "elevation [m]", 
        "relative elevation")
    data[, 2] <- sort(elev, decreasing = T)
    data[, 1] <- cumsum(as.numeric(c(1:length(elev))))/
    max(cumsum(as.numeric(c(1:length(elev)))))
    data[, 3] <- (data[, 2] - min(data[, 2]))/(max(data[, 2]) - 
        min(data[, 2]))
    hi <- sum(data[, 3])/length(data[, 3])
    return(list(data, hi))
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
