\name{toporough.subset}
\alias{toporough.subset}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Multi directional and multi scale relief roughness filter for a subset of points.
}
\description{
Detects rough domains (mri) on a subset of points of a digital elevation model and outputs additional paramatar as direction and widht of the structure.
}
\usage{
toporough.subset(dem, d.subset, type, ngbr, nform, k.diff)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{dem}{
See toporough.
}
  \item{d.subset}{
Matrix of X (col1) and Y(col2) coordinates of subset
}
  \item{type}{
See toporough.
}
  \item{ngbr}{
See toporough.
}
  \item{nform}{
See toporough.
}
  \item{k.diff}{
See toporough.
}
}
\details{
See toporough.
}
\value{
A matrix of extracted parameters and the subset coordinates.
col1: X
col2: Y
col3: mri
col4: k
col5: d
col6: orientation
col7: width
\item{col1 }{X coordinate.}
\item{col2 }{Y coordinate.}
\item{col3 }{Multi roughness index.}
\item{col4 }{k - parameter.}
\item{col5 }{d - parameter.}
\item{col6 }{Geographic orienatation.}
\item{col6 }{Width.}

}
\references{
}
\author{
Sebastian Baumann
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
}
\examples{
data("work.data",package="lineaDEM") #import data
dem.austria<-work.data[[1]]
accu.austria<-work.data[[2]]
track<-track.extrema(accu.austria,c(500000,220000),
9,"max","multi",NA) #generate subset
mri.sub<-toporough.subset(dem.austria,track,"max",51,"quad",NA)
plot(1:length(mri.sub[,1]),mri.sub[,6],
xlab="point number",ylab="orientation [°]")#plot n vs. orientation
lines(1:length(mri.sub[,1]),mri.sub[,6]) 

## The function is currently defined as
function (dem, d.subset, type, ngbr, nform, k.diff) 
{
    res <- (xres(dem) + yres(dem))/2
    if (yres(dem) != xres(dem)) {
        warning("Different raster resolution in x and y direction: 
        (xres+yres)/2 has been used as overall resolution.")
    }
    ngbr.sq <- ngbr^2
    n.neigh <- (ngbr - 1)/2
    mid.coor <- (ngbr + 1)/2
    m.ngb <- matrix(1, ngbr, ngbr)
    m.ngb[((ngbr + 1)/2), (ngbr + 1)/2] <- 0
    cell.sub <- cellFromXY(dem, d.subset)
    adj <- adjacent(dem, cell.sub, m.ngb, include = T, sorted = T)
    adj <- cbind(adj, vector(length = nrow(adj)))
    adj[, 3] <- extract(dem, adj[, 2])
    M.dem <- matrix(NA, nrow = length(cell.sub), ncol = ngbr.sq)
    for (i in c(1:length(cell.sub))) {
        M.dem[i, ] <- adj[adj[, 1] == cell.sub[i], 3]
    }
    n.cells.raster <- length(cell.sub)
    M1.dist <- matrix(1:ngbr, ncol = ngbr, nrow = ngbr, byrow = T)
    M2.dist <- matrix(1:ngbr, ncol = ngbr, nrow = ngbr)
    M.dist <- sqrt((M2.dist - M1.dist[mid.coor, mid.coor]) * 
        (M2.dist - M1.dist[mid.coor, mid.coor]) + (M1.dist - 
        M2.dist[mid.coor, mid.coor]) * (M1.dist - M2.dist[mid.coor, 
        mid.coor]))
    v.dist <- c(M.dist[1:((ngbr.sq - 1)/2)])
    M.point.x <- matrix(v.dist, ncol = ((ngbr.sq - 1)/2), nrow = n.cells.raster, 
        byrow = T)
    M.point.x <- M.point.x * res
    if (nform == "circ") {
        M.dist.circ <- M.dist
        M.dist.circ[M.dist.circ[] > (ngbr - 1)/2] <- NA
        v.dist.circ <- c(M.dist.circ[1:(ngbr.sq)])
        v.dist.circ[!is.na(v.dist.circ)] <- 1
        M.dem <- t(t(M.dem) * v.dist.circ)
    }
    na.max <- function(x) ifelse(!all(is.na(x)), max(x, na.rm = T), 
        NA)
    na.min <- function(x) ifelse(!all(is.na(x)), min(x, na.rm = T), 
        NA)
    M.point.k <- (M.dem[, (ngbr.sq):(((ngbr.sq + 1)/2) + 1)] - 
        ((M.dem[, 1:(((ngbr.sq) - 1)/2)])))/(-M.point.x * 2)
    if (!is.na(k.diff)) {
        M.point.k <- ifelse(M.point.k >= -k.diff & M.point.k <= 
            k.diff, M.point.k, NA)
    }
    M.point.y <- M.dem[, (ngbr.sq):(((ngbr.sq + 1)/2) + 1)]
    M.point.d <- M.point.y - ((M.point.k * (-M.point.x)))
    M.point.d.ver <- (M.point.d - M.dem[, (ngbr.sq + 1)/2])/M.point.x/2
    if (type == "min") {
        rough <- apply(M.point.d.ver, 1, na.min)
        rough.pos <- as.numeric(apply(M.point.d.ver, 1, which.min))
    }
    else {
        rough <- apply(M.point.d.ver, 1, na.max)
        rough.pos <- as.numeric(apply(M.point.d.ver, 1, which.max))
    }
    data <- matrix(NA, ncol = 7, nrow = n.cells.raster)
    colnames(data) <- c("X", "Y", "mri", "k", "d", "dire", "width")
    data[, 1] <- d.subset[, 1]
    data[, 2] <- d.subset[, 2]
    data[, 3] <- rough
    data[, 4] <- sqrt((M.point.k[cbind(1:nrow(M.point.k), rough.pos)])^2)
    data[, 5] <- M.point.d[cbind(1:nrow(M.point.d), rough.pos)] - 
        extract(dem, d.subset)
    v.dire <- rep(c(rep(-1, (ngbr - 1)/2), rep(1, (ngbr + 1)/2)), 
        ngbr)
    M1.dire <- matrix(((ngbr - 1)/-2):((ngbr - 1)/2), ncol = ngbr, 
        nrow = ngbr, byrow = T)
    M2.dire <- (-1) * (matrix(((ngbr - 1)/-2):((ngbr - 1)/2), 
        ncol = ngbr, nrow = ngbr))
    M.dire <- ((M2.dire)/(sqrt(M1.dire^2 + M2.dire^2)))
    M.dire <- acos(M.dire) * 180/pi
    M.dire <- t(t(M.dire) * v.dire)
    M.dire <- t(M.dire)
    v.dire <- M.dire[1:((ngbr.sq - 1)/2)]
    v.dire <- ifelse(v.dire < 0, v.dire + 180, v.dire)
    data[, 6] <- v.dire[rough.pos]
    data[, 7] <- M.point.x[cbind(1:nrow(M.point.x), rough.pos)] * 
        2
    gc()
    return(data)
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
